<?php
// Define the log file
$logFile = __DIR__ . '/torrent_log.txt';

// Function to log messages
function logMessage($message) {
    global $logFile;
    $timestamp = date("Y-m-d H:i:s");
    $logEntry = "[$timestamp] $message" . PHP_EOL;
    file_put_contents($logFile, $logEntry, FILE_APPEND);
}

// Get the hash from the command line arguments
if ($argc != 2) {
    logMessage("Usage: php torrent.php <hash>");
    exit(1);
}
$hash = $argv[1];

// Database credentials
$servername = "localhost";
$username = "saadit5_fsd";
$password = "pSbYzmFkgfe3jmx";
$dbname = "saadit5_jarvis";

// Create connection
$conn = new mysqli($servername, $username, $password, $dbname);

// Check connection
if ($conn->connect_error) {
    logMessage("Connection failed: " . $conn->connect_error);
    exit(1);
}

// Prepare and bind
$stmt = $conn->prepare("SELECT magnet FROM magnets WHERE hash = ?");
$stmt->bind_param("s", $hash);

// Execute the query
$stmt->execute();
$stmt->bind_result($magnet);
$stmt->fetch();

// Close the statement and connection
$stmt->close();
$conn->close();

// Check if a magnet URL was found
if (!$magnet) {
    logMessage("No magnet URL found for hash: $hash");
    exit(1);
}

logMessage("Magnet URL found for hash: $hash");

// Create the folder in the media directory
$mediaDir = __DIR__ . '/media';
if (!file_exists($mediaDir)) {
    mkdir($mediaDir, 0755, true);
    logMessage("Created media directory: $mediaDir");
}

$hashDir = $mediaDir . '/' . $hash;
if (!file_exists($hashDir)) {
    mkdir($hashDir, 0755, true);
    logMessage("Created directory for hash: $hashDir");
}

// Call aria2c to download using the magnet URL
$command = "aria2c --dir=" . escapeshellarg($hashDir) . " --seed-time=0 --async-dns=false " . escapeshellarg($magnet) . " > /dev/null 2>&1 &";
logMessage("Executing command: $command");
exec($command);

logMessage("Download started for hash: $hash");
?>
